/////////////////////////////////////////////
//  texture sampler
/////////////////////////////////////////////
SamplerState textureSampler : register(s0);
Texture2D	diffuseTexture : register(t0);


/////////////////////////////////////////////////////////////////////////////////////
// CBPerFrame constant buffer
/////////////////////////////////////////////////////////////////////////////////////
cbuffer CBPerFrame : register( b0 )
{
    matrix  World;  //!< [hs.
    matrix  View;   //!< r[s.
    matrix  Proj;   //!< ˉes.
	float   AlphaThreshold;  //!< At@臒l
};


/////////////////////////////////////////////////////////////////////////////////////
// VSInput structure
/////////////////////////////////////////////////////////////////////////////////////
struct VSInput
{
    float3 Position : POSITION;     //!< ʒuWł.
    float  PSize    : PSIZE;        //!< |CgTCYł
    float4 color    : DIFFUSE;      //!< _J[ł
};

/////////////////////////////////////////////////////////////////////////////////////
// GSInput structure
/////////////////////////////////////////////////////////////////////////////////////
struct GSInput
{
    float4 Position : SV_POSITION;  //!< ʒuWł.
    float  PSize    : PSIZE;        //!< |CgTCYł
    float4 color    : DIFFUSE;      //!< _J[ł
};
struct PSInput
{
    float4 Position : SV_POSITION;  //!< ʒuWł.
    float4 color    : DIFFUSE;      //!< _J[ł
    float2 texCoord : TEXCOORD0;    //!< uv
};

//-----------------------------------------------------------------------------------
//! @brief      _VF[_Gg[|Cgł.
//-----------------------------------------------------------------------------------
GSInput VSFunc( VSInput input )
{
    GSInput output = (GSInput)0;

    // ̓f[^̂܂ܗ.

    output.Position = float4( input.Position, 1.0f );
    output.PSize    = input.PSize;
    output.color    = input.color;
    return output;
}

//-----------------------------------------------------------------------------------
//! @brief      WIgVF[_Gg[|Cgł.
//-----------------------------------------------------------------------------------
[maxvertexcount(4)]
void GSFunc( point GSInput input[1], inout TriangleStream<PSInput> stream )
{
    PSInput output = (PSInput)0;
	float psize = input[0].PSize;

	output.color = input[0].color;

     // [hԂɕϊ.
    float4 worldPos = mul( World, input[0].Position );

    // r[Ԃɕϊ.
    float4 ordPos  = mul( View,  worldPos );

	//ordPos = float4(0.0f,0.0f, 4.0f,1.0f);

	output.Position = mul(Proj, ordPos + float4(-psize, psize, 0.0f, 0.0f));
	//output.Position = float4(-0.5f,0.5f,0.5f,1.0f);
	output.color = input[0].color;
	output.texCoord = float2(0.0f,0.0f);
    stream.Append( output );
	
	output.Position = mul(Proj, ordPos + float4( psize, psize, 0.0f, 0.0f));
	//output.Position = float4( 0.5f,0.5f,0.5f,1.0f);
	output.color = input[0].color;
	output.texCoord = float2(1.0f,0.0f);
    stream.Append( output );

	output.Position = mul(Proj, ordPos + float4(-psize,-psize, 0.0f, 0.0f));
	//output.Position = float4(-0.5f,-0.5f,0.5f,1.0f);
	output.color = input[0].color;
	output.texCoord = float2(0.0f,1.0f);
    stream.Append( output );

	output.Position = mul(Proj, ordPos + float4( psize,-psize, 0.0f, 0.0f));
	//output.Position = float4( 0.5f,-0.5f,0.5f,1.0f);
	output.color = input[0].color;
	output.texCoord = float2(1.0f,1.0f);
    stream.Append( output );

    stream.RestartStrip();
}
                            
//------------------------------------------------------------------------------------
//! @brief      sNZVF[_Gg[|Cgł.
//------------------------------------------------------------------------------------
float4 PSFunc( PSInput output ) : SV_TARGET0
{
    //return float4( 1.0f, 1.0f, 1.0f, 1.0f );

	float4 pixel = diffuseTexture.Sample(textureSampler, output.texCoord);
	pixel *= output.color;
	return pixel;
}

//------------------------------------------------------------------------------------
//! @brief      sNZVF[_Gg[|Cgł.
//------------------------------------------------------------------------------------
float4 PSFuncNoTex( PSInput output ) : SV_TARGET0
{
//    return float4( 1.0f, 1.0f, 0.0f, 1.0f );
	float4 pixel = output.color;
	if (pixel.w <= AlphaThreshold)
		discard;
	return pixel;
}

